/*
 *$Header: /remet sdk/general/rmtInterfaces.h 130   13.04.07 15:40 Kyselgov $ 
*/


#ifndef _RMTINTERFACES_H__INCLUDED_
#define _RMTINTERFACES_H__INCLUDED_

#pragma once


#include <Unknwn.h>
#include <crtdbg.h>
#include <stdio.h>
#include <tchar.h>


/*!\file
\brief         MM .

-.     ,     
   MM .
*/


#if _MSC_VER < 1300 // early than .NET compiler
	#define rmtInterfaceType			interface
	#define rmtInterface(IID)			rmtInterfaceType __declspec (uuid(IID))
	#define rmtCoClass(CLSID,Interface)	class __declspec (uuid(CLSID))
	#define rmtExClass(CLSID)			class __declspec (uuid(CLSID))
	#define rmtClass					class __declspec (uuid("{00000000-0000-0000-0000-000000000000}"))
	#define RMT_IN						IN
	#define RMT_OUT						OUT
	#define RMT_INOUT					IN OUT
	#define RMT_LCID
	#define RMT_RETVAL
	#define RMT_PURE					= 0
#else
	#define rmtInterfaceType			__interface
	#define rmtInterface(IID)			[uuid(IID)] rmtInterfaceType
	#define rmtCoClass(CLSID,Interface)	[coclass, uuid(CLSID), default(Interface)] class
	#define rmtExClass(CLSID)			[uuid(CLSID)] class
	#define rmtClass					[uuid("{00000000-0000-0000-0000-000000000000}")] class
	#define RMT_IN						[in]
	#define RMT_OUT						[out]
	#define RMT_INOUT					[in, out]
	#define RMT_LCID					[lcid]
	#define RMT_RETVAL					[out, retval]
	#define RMT_PURE
#endif


/*!
\defgroup group_rmtMM  Remet selfManaged Modules (rmtMM)

    , ,   .. 
    Remet selfManaged Modules.
 ,   ..       .
*/

/*!
\defgroup group_rmtKernel  rmtKernel

    ,   , 
     rmtKernel,    
  Remet selfManaged Modules.

\ingroup group_rmtMM
*/

/*!
\defgroup group_rmtKernelClass    

\ingroup group_rmtKernel
*/

/*!
\defgroup group_rmtKernelModule    

\ingroup group_rmtKernel
*/

/*!
\defgroup group_rmtKernelNamespace     

\ingroup group_rmtKernel
*/

/*!
\defgroup group_rmtKernelDLLStrategy  DLL 

\ingroup group_rmtKernel
*/

/*!
\defgroup group_rmtKernelLocaly  

\ingroup group_rmtKernel
*/

/*!
\defgroup group_rmtKernelDependency   

\ingroup group_rmtKernel
*/

/*!
\defgroup group_rmtKernelSync    

\ingroup group_rmtKernel
*/

/*!
\defgroup group_rmtKernelPlatform   

\ingroup group_rmtKernel
*/

/*!
\defgroup group_rmtKernelVersion  

\ingroup group_rmtKernel
*/



/*!
\defgroup group_rmtMModules MM 

    ,   , 
       MM .

\ingroup group_rmtMM
*/

/*!
\defgroup group_rmtMClasses MM 

    ,   , 
       MM .

\ingroup group_rmtMM
*/


/*!
\defgroup group_rmtMNamespaces MM  

    ,   , 
        .

\ingroup group_rmtMM
*/

/*!
\defgroup group_rmtDataStorages  

    , ,  ,  
     ,    .. 
   :
	- .
	- .
	- .
	-  ..
*/


/*!
\defgroup group_rmtSerialization  

\ingroup group_rmtDataStorages
*/

/*!
\defgroup group_rmtXML XML

\ingroup group_rmtSerialization
*/

/*!
\defgroup group_rmtXMLDOM XML DOM

\ingroup group_rmtXML
*/

/*!
\defgroup group_rmtXMLSAX XML SAX

\ingroup group_rmtXML
*/

/*!
\defgroup group_rmtTxtStorages  

\ingroup group_rmtSerialization
*/

/*!
\defgroup group_rmtFileStorages  

\ingroup group_rmtSerialization
*/


/*!
\defgroup group_rmtArrays  

\ingroup group_rmtDataStorages
*/


/*!
\defgroup group_rmtLists  

\ingroup group_rmtDataStorages
*/


/*!
\defgroup group_rmtMaps  

\ingroup group_rmtDataStorages
*/


/*!
\defgroup group_rmtCaches  

\ingroup group_rmtDataStorages
*/


/*!
\defgroup group_rmtTools 

   , , , -  .. 
  ,    - 
 .
*/


/*!
\defgroup group_rmtLocaly  

   , , , -  .. 
     ,    
       .

\ingroup group_rmtTools
*/


/*!
\defgroup group_rmtDelayCall  

   , , , -  .. 
       , .. <b>Delay Callback</b>.

\ingroup group_rmtTimer
*/


/*!
\defgroup group_rmtValid  

   , , , -  .. 
        , ..   
    .

\ingroup group_rmtTools
*/


/*!
\defgroup group_rmtPlatform   

   , , , -  .. 
   ,      ..

\ingroup group_rmtTools
*/


/*!
\defgroup group_rmtAutoPtr 

          - 
   /.

\ingroup group_rmtTools
*/


/*!
\defgroup group_rmtDLL DLL 

   -,       DLL .

\ingroup group_rmtTools
*/


/*!
\defgroup group_rmtThreading  

\ingroup group_rmtTools
*/

/*!
\defgroup group_rmtSync 

\ingroup group_rmtThreading
*/

/*!
\brief   

       .

    ,  
      . , 
       ,  
 ,         
         ,
  ,    ,     
  ,   saferelease().

   :
	- IrmtClassFactory2::GetClassInterfaces()

\ingroup group_rmtMClasses
\ingroup group_rmtKernelClass
*/
struct rmtMM_INTERFACE
{
// 
public:
	DWORD			m_dwSize;		//!<  
	IID				m_InterfaceID;	//!<   (IID)
	BSTR			m_InterfaceName;//!<     

// C++ 
public:
	
	rmtMM_INTERFACE()
		: m_dwSize(sizeof(rmtMM_INTERFACE))
		, m_InterfaceID(IID_NULL)
		, m_InterfaceName(NULL)
	{
	}

	~rmtMM_INTERFACE()
	{
		saferelease();
	}

	/*!
	\brief      .

	   ,     
	     . 

	       
	 .
	*/
	inline void saferelease()
	{
		if (m_InterfaceName!=NULL)
		{
			::SysFreeString(m_InterfaceName);
			m_InterfaceName = NULL;
		}
	}
};

/*!
\brief   MM 

       MM .

    ,  
      . , 
       ,  
 ,         
         ,
  ,    ,     
  ,   saferelease().


\~
\sa rmtMM_CLASS2
\sa rmtMM_CLASS3
\sa IrmtRTClassesEnum
\sa IrmtRTClassesSearch2

\ingroup group_rmtMClasses
\ingroup group_rmtKernelClass
*/
struct rmtMM_CLASS
{
// 
public:
	DWORD			m_dwSize;		//!<  

	CLSID			m_ClassID;		//!<   (CLSID)
	BSTR			m_ClassName;	//!<     

// C++ 
public:
	
	rmtMM_CLASS()
		: m_dwSize(sizeof(rmtMM_CLASS))
		, m_ClassID(CLSID_NULL)
		, m_ClassName(NULL)
	{
	}

	~rmtMM_CLASS()
	{
		saferelease();
	}

	/*!
	\brief        .

	        
	     , ..  
	  "::".
	*/
	inline static LPCOLESTR GetClassName(LPCOLESTR szFullClassName)
	{
		C_ASSERT( sizeof(OLECHAR)==sizeof(WCHAR) );

		static const LPCWSTR szDelim = L"::";
		static const size_t nDelimLen= wcslen(szDelim);
		
		LPCWSTR szPos = wcsstr(szFullClassName, szDelim);
		while (szPos!=NULL)
		{
			szFullClassName = szPos + nDelimLen;
			szPos = wcsstr(szFullClassName, szDelim);
		}

		return szFullClassName;
	}
	
	/*!
	\brief        .

	           
	     , ..  
	  "::".
	*/
	inline LPCOLESTR GetClassName() const
	{
		return GetClassName(m_ClassName);
	}

	/*!
	\brief      .

	   ,     
	     . 

	       
	 .
	*/
	inline void saferelease()
	{
		if (m_ClassName!=NULL)
		{
			::SysFreeString(m_ClassName);
			m_ClassName = NULL;
		}
	}
};

/*!
\brief   MM 

     rmtMM_CLASS,  
        rmtMM_CLASS   
 ,  IrmtRTClassesEnum  IrmtRTClassesSearch2.

\warning
       - m_pFactory. 
     , ..   "" 
     . -  
      saferelease().   
    ,    .

\~
\sa rmtMM_CLASS
\sa rmtMM_CLASS3
\sa IrmtRTClassesEnum
\sa IrmtRTClassesSearch2

\ingroup group_rmtMClasses
\ingroup group_rmtKernelClass
*/
struct rmtMM_CLASS2 
	: public rmtMM_CLASS
{
// 
public:

	BSTR			m_ModuleName;		//!<         

	/*!
	\brief       IClassFactory

	      ,     .
	   , ..   NULL,  <b></b>  
	       ,       .
	,   ,        <b></b>.
	:

	\code
	//     
	IrmtRTClassesSearch2* pSearch;

	// 
	IClassFactory* pFactory	= NULL;

	//  
	rmtMM_CLASS2 classinfo;

	//     
	classinfo.m_ClassName	= ::SysAllocString( L("MyClass") );
	classinfo.m_pFactory	= &pFactory;

	//  
	if (pSearch->FindClass(&classinfo)==NOERROR)
	{
		//    ...
		pFactory->CreateInstance(...);

		//  
		pFactory->Release();
	};
	\endcode
	*/
	IClassFactory**	m_pFactory;
	
	WORD			m_nMajorVersion;	//!<   ( ,  )
	WORD			m_nMinorVersion;	//!<   (,  )
	WORD			m_nMajorBuild;		//!<   (  )
	WORD			m_nMinorBuild;		//!<   ( )

// C++ 
public:

	rmtMM_CLASS2()
		: m_ModuleName(NULL)
		, m_pFactory(NULL)
		, m_nMajorVersion(0)
		, m_nMinorVersion(0)
		, m_nMajorBuild(0)
		, m_nMinorBuild(0)
	{
		m_dwSize = sizeof(rmtMM_CLASS2);
	}

	~rmtMM_CLASS2()
	{
		saferelease();
	}


	inline void saferelease()
	{
		__super::saferelease();

		if (m_ModuleName!=NULL)
		{
			::SysFreeString(m_ModuleName);
			m_ModuleName = NULL;
		}
	}
};



/*!
\brief   MM 

     rmtMM_CLASS2      rmtMM_CLASS, rmtMM_CLASS2   
 ,  IrmtRTClassesEnum  IrmtRTClassesSearch2.
,       rmtMM_CLASS3   . 
     ,    rmtMM_CLASS3.
   -        .   
           .

\~
\sa rmtMM_CLASS
\sa rmtMM_CLASS2
\sa IrmtRTClassesEnum
\sa IrmtRTClassesSearch2

\ingroup group_rmtMClasses
\ingroup group_rmtKernelClass
*/
struct rmtMM_CLASS3 
	: public rmtMM_CLASS2
{
// 
public:

	/*!
	\brief BOOL , TRUE -   , FALSE -    

	      rmtMM_CLASS3       ,   , 
	      m_bIsDependencyOk   BOOL .       -
	m_bIsDependencyOk   TRUE.
	*/
	BOOL			m_bIsDependencyOk;

// ++ 
public:

	rmtMM_CLASS3()
		: m_bIsDependencyOk(FALSE)
	{
		m_dwSize = sizeof(rmtMM_CLASS3);
	}
};

/*!
\brief   MM 

   rmtMM_CLASS4  
    .

\~
\sa rmtMM_CLASS
\sa rmtMM_CLASS2
\sa IrmtRTClassesEnum
\sa IrmtRTClassesSearch2

\ingroup group_rmtMClasses
\ingroup group_rmtKernelClass

*/
struct rmtMM_CLASS4 
	: public rmtMM_CLASS3
{
// 
public:
	BSTR			m_DependencyDescription;

// C++ 
public:

	rmtMM_CLASS4()
		: m_DependencyDescription(NULL)
	{
		m_dwSize = sizeof(rmtMM_CLASS4);
	}

	~rmtMM_CLASS4()
	{
		saferelease();
	}

	inline void saferelease()
	{
		__super::saferelease();

		if (m_DependencyDescription!=NULL)
		{
			::SysFreeString(m_DependencyDescription);
			m_DependencyDescription = NULL;
		}
	}

};

/*!
\brief   MM 

       MM .
      , <b></b> 
    :

\code
//  
rmtMM_MODULE moduleinfo = {0};

//   
moduleinfo.m_dwSize = sizeof(rmtMM_MODULE);
\endcode

   ,      
<b></b>   ,   rmtMM_MODULE::m_ModuleName, rmtMM_MODULE::m_ModuleLoadPath 
rmtMM_MODULE::m_ModuleFolderPath.
   <b></b> .

\code 
//  
::SysFreeString(moduleinfo.m_ModuleName);
::SysFreeString(moduleinfo.m_ModuleLoadPath);
::SysFreeString(moduleinfo.m_ModuleFolderPath);
\endcode

\sa IrmtRTModulesEnum

\ingroup group_rmtMModules
\ingroup group_rmtKernelModule
*/
struct rmtMM_MODULE
{
	/*
	\brief  ,     sizeof(rmtMM_MODULE)
	*/
	DWORD			m_dwSize;
	
	//   
	
	/*
	\brief    
	*/
	BSTR			m_ModuleName;
	
	/*
	\brief     ,    
	*/
	BSTR			m_ModuleLoadPath;
	
	/*
	\brief       ,    .        .
	*/
	BSTR			m_ModuleFolderPath;
	
    
	//  
	
	/*
	\brief ,  TRUE,  " "  ,       
	*/
	BOOL			m_bIsDependencyOk;

	//  

	/*
	\brief  ,  TRUE,      "", ..  - rmtQuery()
	*/
	BOOL			m_bQuerySupported;

	/*
	\brief ,  TRUE,     rmtCanUnloadNow()
	*/
	BOOL			m_bCanUnloadSupported;

	/*
	\brief ,  TRUE,     IrmtModuleService 
	
	\note   ,   rmtMM_MODULE::m_bQuerySupported == TRUE
	*/
	BOOL			m_bModuleServiceSupported;

	/*
	\brief ,  TRUE,     IrmtRTDependency 
	
	\note   ,   rmtMM_MODULE::m_bQuerySupported == TRUE
	*/
	BOOL			m_bDependencyServiceSupported;

	/*
	\brief ,  TRUE,     IrmtRTClassesEnum 
	
	\note   ,   rmtMM_MODULE::m_bQuerySupported == TRUE
	*/
	BOOL			m_bClassEnumSupported;

	/*
	\brief ,  TRUE,     IrmtRTClassesSearch 
	
	\note   ,   rmtMM_MODULE::m_bQuerySupported == TRUE
	*/
	BOOL			m_bClassSearchSupported;

	/*
	\brief ,  TRUE,     IrmtRTLanguage 
	
	\note   ,   rmtMM_MODULE::m_bQuerySupported == TRUE
	*/
	BOOL			m_bLanguageSupported;

	/*
	\brief ,  TRUE,     IrmtVersionInfo 
	
	\note   ,   rmtMM_MODULE::m_bQuerySupported == TRUE
	*/
	BOOL			m_bVersionSupported;


	//  
	
	/*
	\brief   ( ,  )
	*/
	WORD			m_nMajorVersion;
	
	/*
	\brief   (,  )
	*/
	WORD			m_nMinorVersion;
	
	/*
	\brief   (  )
	*/
	WORD			m_nMajorBuild;
	
	/*
	\brief   ( )
	*/
	WORD			m_nMinorBuild;
};

struct rmtMM_MODULE2 : public rmtMM_MODULE
{
	BSTR			m_DependencyDescription;
};

namespace rmt
{
	/*!
	\brief  ,       .

	\ingroup group_rmtUI
	*/
	namespace Wnd
	{
		/*!
		\brief     

		     IrmtWndCommandProc    
		   .

		\note
			   1.4.60406.0    .   
			         .

		\ingroup group_rmtUI
		*/
		struct CommandState
		{

		// 
		public:

			/*!
			\brief     (m_dwMask).
			*/
			enum MaskCodes
			{
				maskEnable		= 0x01,	//!<  m_bEnable   .
				maskState		= 0x02,	//!<  m_nState   .
				maskText		= 0x04,	//!<  m_strText   .
			};

			/*!
			\brief    ,    sizeof(rmt::Wnd::CommandState).
			*/
			DWORD		m_dwSize;

			/*!
			\brief .

			      , .. 
			   (   rmt::Wnd::CommandState::mask????)
			*/
			DWORD		m_dwMask;

			/*!
			\brief    .
			*/
			BOOL		m_bEnable;

			/*!
			\brief  .

			   :
			- 0 -  (     )
			- 1 -  (   )
			- 2 -  (          )
			*/
			UINT		m_nState;

			/*!
			\brief   .

			\note
				  1.4.60406.0    m_bRadio   radio 
				.  ..     m_nState,  m_bRadio  .
				        .
			*/
			UINT		m_nReserved;

			/*!
			\brief  .

			   ,    
			 :
			-   ()
			-   
			- 
			-  ..

			      .
			*/
			BSTR		m_strText;

		// ++ 
		public:
			CommandState()
				: m_dwSize(sizeof(CommandState))
				, m_dwMask(0)
				, m_bEnable(FALSE)
				, m_nState(0)
				, m_nReserved(0)
				, m_strText(NULL)
			{
			}

			~CommandState()
			{
				if (m_strText!=NULL)
					::SysFreeString(m_strText);
			}

			void Enable(bool bEnable = true)
			{
				m_bEnable	= bEnable;
				m_dwMask	|= rmt::Wnd::CommandState::maskEnable;
			}

			void SetState(UINT nState = 0)
			{
				if (nState<=2)
				{
					m_nState	= nState;
					m_dwMask	|= rmt::Wnd::CommandState::maskState;
				}
			}

			void SetText(BSTR szText)
			{
				if (szText!=NULL)
				{
					if (m_strText!=NULL)
						::SysFreeString(m_strText);

					m_strText	= szText;
					m_dwMask	|= rmt::Wnd::CommandState::maskText;
				}
			}

#ifdef __ATLCONV_H__

			void SetText(LPCOLESTR szText)
			{
				if (szText!=NULL)
				{
					SetText( OLE2BSTR(szText) );
				}
			}

			void SetText(LPCTSTR szText)
			{
				if (szText!=NULL)
				{
					SetText( CT2COLE(szText) );
				}
			}
#endif
		};
	}

	/*!
	\brief  ,       .

	\ingroup group_rmtKernel
	*/
	namespace Kernel
	{
		/*!
		\brief  ,      .

		         rmt::Kernel::Settings
	
		\version 
		- <b>1.4.50517.0</b> -    rmtKernel

		\ingroup group_rmtKernel
		*/
		enum enUseFlags
		{
			/*!
			\brief ""       .

			   ,       
			   "" ,       
			.    ,    .
			     -     ""  ,
			       .     
			           , 
			.     ,     ,  
			       .
			*/
			uf_ModuleEconomyStrategy	= 0x0001,			

			uf_BogusLast				= 0xFFFF
		};

		/*!
		\brief    .

		    ,    
		   rmtKernel   ::IrmtKernel2.

		\ingroup group_rmtKernel
		*/
		struct Settings
		{
			/*!
			\brief    .
			
			   sizeof(rmt::Kernel::Settings).
			*/
			DWORD		m_dwSize;

			/*!
			\brief           .

			    ,    / ,   ,
			          .   ,
			           .
			
			\note
			       -,     NULL.
			
			\warning
			  ,        .
			*/
			BSTR		m_strKernelFolderPath;

			/*!
			\brief            .

			      ,      .   
			 ,       ,      .

			\note
			        ,     NULL.
			
			\warning
			  ,        .
			*/
			BSTR		m_strTempFolderPath;


			/*!
			\brief " "   .     .

			        ,   
			 .      -      "", , ,
			 .

			  - 300, .. 5 .

			\note
			   "0" -    .

			\version
			- <b>1.4.50513.0</b> -    rmtKernel
			*/
			DWORD		m_nModulesLifeTime;
			

			/*!
			\brief " "   .     .

			          ,   
			 .      -      "", , ,
			 .   ,     ,     
			.

			  - 120, .. 2 .

			\note
			   "0" -    .

			\version
			- <b>1.4.50520.0</b> -    rmtKernel
			*/
			DWORD		m_nClassesLifeTime;

			/*!
			\brief     .

			       rmt::Kerenl::enUseFlags
			
			\note
			 " " - "0".

			\version
			- <b>1.4.50517.0</b> -    rmtKernel
			*/
			DWORD		m_nUsageFlags;

			/*!
			\brief   .DLL 

			    ,
			    .DLL .
			
			    ::IrmtModuleLoader.

			\warning
			      MFC  
			   .DLL    - AfxLoadLibrary()
			 AfxFreeLibrary(),        
			  MFC.
			..       ATL,  MFC  ,
			    .DLL     API  LoadLibrary(), LoadLibraryEx(),
			FreeLibrary(). ,        MFC  
			MM ,     MFC, ,   
			,       ,  ,   
			  ,    ""     ::IrmtModuleUnloader 
			::IrmtModuleLoader.  ,   rmtObject.h  rmtObject.cpp   
			   rmt::Module::CLoadStrategy.

			\version
			- <b>1.4.50520.0</b> -    rmtKernel
			*/
			IUnknown*	m_pModuleLoadStrategy;

			/*!
			\brief   .DLL 
			
			    ,
			    .DLL .
			
			    ::IrmtModuleUnloader.

			\note
			        ,
			         .
			..         ::IrmtModuleUnloader::unload_Background,
			        .

			\warning
			      MFC  
			   .DLL    - AfxLoadLibrary()
			 AfxFreeLibrary(),        
			  MFC.
			..       ATL,  MFC  ,
			    .DLL     API  LoadLibrary(), LoadLibraryEx(),
			FreeLibrary(). ,        MFC  
			MM ,     MFC, ,   
			,       ,  ,   
			  ,    ""     ::IrmtModuleUnloader 
			::IrmtModuleLoader.  ,   rmtObject.h  rmtObject.cpp   
			   rmt::Module::CLoadStrategy.

			\version
			- <b>1.4.50519.0</b> -    rmtKernel
			*/
			IUnknown*	m_pModuleUnloadStrategy;

		public:
			Settings()
				: m_dwSize(sizeof(rmt::Kernel::Settings))
				, m_strKernelFolderPath(NULL)
				, m_strTempFolderPath(NULL)
				, m_nModulesLifeTime(300)
				, m_nClassesLifeTime(120)
				, m_nUsageFlags(0)
				, m_pModuleLoadStrategy(NULL)
				, m_pModuleUnloadStrategy(NULL)
			{};
		};
	}

	/*!
	
	\ingroup group_rmtKernelDependency
	*/
	namespace Dependency
	{
		/*!

		\ingroup group_rmtKernelDependency
		*/
		enum Type
		{
			dt_Kernel,
			dt_Class,
			dt_Module,
			dt_DLL,
			dt_XML,
			dt_OS,
			dt_IE,
			dt_DirectX,
			dt_Desktop,
			dt_Memory,

			dt_BogusLast
		};

		/*!

		\ingroup group_rmtKernelDependency
		*/
		struct Base
		{
			DWORD			m_Size;			//!<  
			Type			m_Type;			//!<    (   rmt::Dependency::Type)
		};

		/*!

		\ingroup group_rmtKernelDependency
		*/
		struct Version /*: public Base*/
		{
			/*Base */
			DWORD			m_Size;			//!<  
			Type			m_Type;			//!<    (   rmt::Dependency::Type)

			/*Version */
			WORD			m_nMajorVersion;//!<  ( ,  )
			WORD			m_nMinorVersion;//!<  (,  )
			WORD			m_nMajorBuild;	//!<  (  )
			WORD			m_nMinorBuild;	//!<  ( )
		};

		/*!

		\ingroup group_rmtKernelDependency
		*/
		struct Class /*: public Version*/
		{
			/*Base */
			DWORD			m_Size;			//!<  
			Type			m_Type;			//!<    (   rmt::Dependency::Type)

			/*Version */
			WORD			m_nMajorVersion;//!<  ( ,  )
			WORD			m_nMinorVersion;//!<  (,  )
			WORD			m_nMajorBuild;	//!<  (  )
			WORD			m_nMinorBuild;	//!<  ( )

			/*Class */
			CLSID			m_ClassID;		//!<   (CLSID)
			LPCOLESTR		m_ClassName;	//!<    
		};

		/*!

		\ingroup group_rmtKernelDependency
		*/
		struct Module /*: public Version*/
		{
			/*Base */
			DWORD			m_Size;			//!<  
			Type			m_Type;			//!<    (   rmt::Dependency::Type)

			/*Version */
			WORD			m_nMajorVersion;//!<  ( ,  )
			WORD			m_nMinorVersion;//!<  (,  )
			WORD			m_nMajorBuild;	//!<  (  )
			WORD			m_nMinorBuild;	//!<  ( )

			/*Module */
			LPCOLESTR		m_ModuleName;	//!<       
		};

		/*!

		\ingroup group_rmtKernelDependency
		*/
		struct XML /*: public Version*/
		{
		public:
			enum enParserType
			{
				parser_3,
				parser_4,

				parser_BogusLast
			};

		public:
			/*Base */
			DWORD			m_Size;			//!<  
			Type			m_Type;			//!<    (   rmt::Dependency::Type)

			/*Version */
			WORD			m_nMajorVersion;//!< DLL   ( ,  )
			WORD			m_nMinorVersion;//!< DLL   (,  )
			WORD			m_nMajorBuild;	//!< DLL   (  )
			WORD			m_nMinorBuild;	//!< DLL   ( )

			/*XML */
			enParserType	m_XMLType;		//!<   XML 
		};

		struct Desktop /*: public Version*/
		{
		public:
			/*Base */
			DWORD			m_Size;			//!<  
			Type			m_Type;			//!<    (   rmt::Dependency::Type)
		
			/*Desktop */
			UINT			m_Width;
			UINT			m_Height;
			UINT			m_BPP;
			UINT			m_MonitorsCount;
		};

		struct Memory /*: public Version*/
		{
		public:
			/*Base */
			DWORD			m_Size;			//!<  
			Type			m_Type;			//!<    (   rmt::Dependency::Type)
		
			/*Desktop */
			SIZE_T			m_TotalPhys_bytes;
			SIZE_T			m_AvailPhys_bytes;
		};

		/*!

		\ingroup group_rmtKernelDependency
		*/
		typedef Module DLL;

		/*!

		\ingroup group_rmtKernelDependency
		*/
		typedef Version Kernel;

		/*!

		\ingroup group_rmtKernelDependency
		*/
		typedef Version OS;

		/*!

		\ingroup group_rmtKernelDependency
		*/
		typedef Version IE;

		/*!

		\ingroup group_rmtKernelDependency
		*/
		typedef Version DirectX;
	}

	/*!
	\brief        (DLL, EXE)

	\ingroup group_rmtDLL
	*/
	namespace Module
	{
		/*!
		\brief    , 
		 ::IrmtModuleUnloader

		\ingroup group_rmtDLL
		*/
		enum UnloadMethod
		{
			unload_Background,		//!<     (    idle )
			unload_Now,				//!<      ::IrmtModuleUnloader::Unload()

			unload_BodusLast		//!<  .
		};

		/*!
		\brief    , 
		 ::IrmtModuleLoader
		
		\ingroup group_rmtDLL
		*/
		enum LoadMethod
		{
			load_StdModule,					//!<   .
			load_StdModuleNoInitialize,		//!<   ,   .      OS,     !
			load_Datafile,					//!<    .	     OS   .

			load_BogusLast					//!<  .
		};
	}
}

/*!
\brief    MM 

         .    
      .

\ingroup group_rmtKernel
*/
rmtInterface("{333C5B70-3C1D-4b87-B7CB-687B38472A9A}") 
IrmtKernel : public IUnknown
{
	/*!
	\brief    

	           .
	     ,    
	
	\param szPath -    
	\return	  HRESULT.
	*/
	virtual HRESULT	STDMETHODCALLTYPE	AddModule(RMT_IN BSTR szPath) RMT_PURE;

	/*!
	\brief    

	           .
	     ,    

	\param szPath -    
	\param szFolderPath -      .              .
	\return	  HRESULT
	*/
	virtual HRESULT	STDMETHODCALLTYPE	AddModuleEx(RMT_IN BSTR szPath, RMT_IN BSTR szFolderPath) RMT_PURE;

	/*!
	\brief    

	             
	\param szPath -    
	\return	  HRESULT
	*/
	virtual HRESULT	STDMETHODCALLTYPE	RemoveModule(RMT_IN BSTR szPath) RMT_PURE;

	/*!
	\brief     

	 -     ,      .
	  -      , ..        
	,   
	\return	  HRESULT
	*/
	virtual HRESULT	STDMETHODCALLTYPE	RemoveAllModules() RMT_PURE;
	
	/*!
	\brief      

	      .
	\param szName -   
	\param riid -  ,       
	\param ppvObject -    ,     
	\return	  HRESULT
	*/
	virtual HRESULT	STDMETHODCALLTYPE	CreateObjectByName(RMT_IN BSTR szName, RMT_IN REFIID riid, RMT_RETVAL void __RPC_FAR *__RPC_FAR *ppvObject) RMT_PURE;
	
	/*!
	\brief     

	    
	\param rclsid -  
	\param riid -  ,       
	\param ppvObject -    ,     
	\return	  HRESULT
	*/
	virtual HRESULT	STDMETHODCALLTYPE	CreateObjectByID(RMT_IN REFCLSID rclsid, RMT_IN REFIID riid, RMT_RETVAL void __RPC_FAR *__RPC_FAR *ppvObject) RMT_PURE;
};
#define IID_IrmtKernel __uuidof(IrmtKernel)
           

/*!
\brief    MM 

     ::IrmtKernel  
      .

\ingroup group_rmtKernel
*/
rmtInterface("{259F5323-B46A-42ce-865F-93FAD1699C40}") 
IrmtKernel2 : public IrmtKernel
{
	/*!
	\brief  .

	  ,     ,     
	,          .
	    -    , ..  
	.      -     .

	\param pInitSettings -   ,   .           .
	\return	  HRESULT.
	*/
	virtual HRESULT	STDMETHODCALLTYPE	Init(RMT_IN rmt::Kernel::Settings* pInitSettings) RMT_PURE;
};
#define IID_IrmtKernel2 __uuidof(IrmtKernel2)


/*!
\brief   .

     .

\ingroup group_rmtKernelDependency
*/
rmtInterface("{18985553-40E2-441e-BA0A-3BE640A0763B}")
IrmtEnvironmentChecker : public IUnknown
{
	virtual HRESULT	STDMETHODCALLTYPE	CheckDependency(RMT_IN rmt::Dependency::Base *pDependency, RMT_INOUT LPBSTR pszDescription = NULL) RMT_PURE;
};
#define IID_IrmtEnvironmentChecker __uuidof(IrmtEnvironmentChecker)


/*!
\brief   "" .

     .
    :
-   
-    (    idle )

\version
- <b>1.4.50513.0</b> -    rmtKernel

\ingroup group_rmtKernelDLLStrategy
\ingroup group_rmtDLL
*/
rmtInterface("{9FD1A4F8-C872-4d36-8AFA-B07FF99C2E24}") 
IrmtModuleUnloader : public IUnknown
{
	/*!
	\brief  .
	
	    .

	\param hModule -  .
	\param bBackgroundUnload -  .
	\return HRESULT -   .
	*/
	virtual HRESULT	STDMETHODCALLTYPE	Unload(RMT_IN HMODULE hModule, RMT_IN rmt::Module::UnloadMethod nMethod = rmt::Module::unload_Background) RMT_PURE;
};
#define IID_IrmtModuleUnloader __uuidof(IrmtModuleUnloader)


/*!
\brief   "" .

     .
    :
- 
- ,       
-   

\version
- <b>1.4.50520.0</b> -    rmtKernel

\ingroup group_rmtKernelDLLStrategy
\ingroup group_rmtDLL
*/
rmtInterface("{833A4269-C0AD-4b39-89F1-53F792093FA1}") 
IrmtModuleLoader : public IUnknown
{
	/*!
	\brief     .

	     ,     (nMethod).
	         (szModulePath),     
	       (szSearchPath),     , ..
	szSearchPath==NULL,         .

	\param szModulePath -     /   
	\param szSearchPath	-       ,     ,    
						     .     (szSearchPath==NULL),
						     OS .
	\param nMethod -  .     IrmtModuleLoader::Method
	\retval phModule -  ,    .
	\return HRESULT -   .
	*/
	virtual HRESULT	STDMETHODCALLTYPE	Load(RMT_IN LPCOLESTR szModulePath, RMT_IN LPCOLESTR szSearchPath, RMT_IN rmt::Module::LoadMethod nMethod, RMT_RETVAL HMODULE* phModule) RMT_PURE;
};
#define IID_IrmtModuleLoader __uuidof(IrmtModuleLoader)


/*!
\brief C     .

   .

\ingroup group_rmtMNamespaces
\ingroup group_rmtKernelNamespace
*/
rmtInterface("{BBEEB0C7-DE90-4d7e-9CB8-FC5785D78473}")
IrmtNamespace : public IUnknown
{
	/*!
	\brief    .

	 bFull == TRUE -   .
	*/
	virtual HRESULT	STDMETHODCALLTYPE	GetNamespace(RMT_IN BOOL bFull, RMT_INOUT LPBSTR pszName) RMT_PURE;

	/*!
	\brief    .
	*/
	virtual HRESULT	STDMETHODCALLTYPE	QueryParentNamespace(RMT_RETVAL IrmtNamespace __RPC_FAR * __RPC_FAR* ppvNamespace) RMT_PURE;

	/*!
	\brief     ().
	*/
	virtual HRESULT	STDMETHODCALLTYPE	QuerySubNamespace(RMT_IN BSTR szNamespace, RMT_RETVAL IrmtNamespace __RPC_FAR * __RPC_FAR* ppvNamespace) RMT_PURE;
};
#define IID_IrmtNamespace __uuidof(IrmtNamespace)


/*!
\brief     .

   .

\ingroup group_rmtMNamespaces
\ingroup group_rmtKernelNamespace
*/
rmtInterface("{F8F99730-F007-45fa-BAAD-A5CFA586A672}")
IrmtNamespaceEnum : public IUnknown
{
	virtual HRESULT	STDMETHODCALLTYPE	Next(RMT_IN ULONG celt, RMT_OUT IrmtNamespace **ppNamespaces, RMT_INOUT ULONG *pceltFetched) RMT_PURE;
	virtual HRESULT	STDMETHODCALLTYPE	Skip(RMT_IN ULONG celt) RMT_PURE;
	virtual HRESULT	STDMETHODCALLTYPE	Reset() RMT_PURE;
	virtual HRESULT	STDMETHODCALLTYPE	Clone(RMT_OUT IrmtNamespaceEnum **ppenum) RMT_PURE;
};
#define IID_IrmtNamespaceEnum __uuidof(IrmtNamespaceEnum)


/*!
\brief    .

 NOERROR(S_OK)     .
     ppCF   ,   (*ppCF)      .

        .

\ingroup group_rmtMClasses
\ingroup group_rmtKernelClass
*/
rmtInterface("{77990003-5686-4ecb-9967-9CE4FD5341D5}")
IrmtRTClassesSearch : public IUnknown
{
	/*!
	\brief     .

	      .    ,
	..      ,       
	.
	
	\param szClassName -  .
	\retval IClassFactory -  , ,   .
	\return HRESULT -  : S_OK -  , S_FALSE, E_??? _   .
	*/
	virtual HRESULT	STDMETHODCALLTYPE	FindClassByName(RMT_IN BSTR szClassName, RMT_RETVAL IClassFactory **ppCF) RMT_PURE;
	
	/*!
	\brief     .

	     .
	
	\param rclsid -  .
	\retval IClassFactory -  , ,   .
	\return HRESULT -  : S_OK -  , S_FALSE, E_??? _   .
	*/
	virtual HRESULT	STDMETHODCALLTYPE	FindClassByID(RMT_IN REFCLSID rclsid, RMT_RETVAL IClassFactory **ppCF) RMT_PURE;
	
	
	/*!
	\brief      / .

	       / .       :
	-   (rclsid  , ..  CLSID_NULL, szClassName - )
	-   (rclsid , szClassName -  , ..  NULL)
	-     (rclsid , szClassName - )
	
	   , ..,   ,        ,
	       .
	
	\param rclsid -  .
	\param szClassName -  .
	\retval IClassFactory -  , ,   .
	\return HRESULT -  : S_OK -  , S_FALSE, E_??? _   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	FindClassByIDAndName(RMT_IN REFCLSID rclsid, RMT_IN BSTR szClassName, RMT_RETVAL IClassFactory **ppCF) RMT_PURE;
};
#define IID_IrmtRTClassesSearch __uuidof(IrmtRTClassesSearch)
                               

/*!
\brief    .

    ,     
.

\version
- <b>0.2.3.0</b> -    rmtKernel   rmtMM

\ingroup group_rmtMClasses
\ingroup group_rmtKernelClass
*/
rmtInterface("{1116A791-DA81-4f1a-9362-E8E7EC387157}")
IrmtRTClassesSearch2 : public IrmtRTClassesSearch
{
	/*!
	\brief      / .

	       / .
	       pClassInfo.

	      :
	-   (pClassInfo->m_ClassID  , ..  CLSID_NULL, pClassInfo->m_ClassName - )
	-   (pClassInfo->m_ClassID , pClassInfo->m_ClassName -  , ..  NULL)
	-     (pClassInfo->m_ClassID , pClassInfo->m_ClassName - )
	
	   ,         pClassInfo.
	       ,     pClassInfo,
	..       : rmtMM_CLASS, rmtMM_CLASS2, rmtMM_CLASS3  ..

	\note
	   , ..,   ,        ,
	       .
	
	\param pClassInfo -   ,     : rmtMM_CLASS, rmtMM_CLASS2, rmtMM_CLASS3  ..
	\return HRESULT -  : S_OK -  , S_FALSE, E_??? _   .

	             - 
	 rmtMM_CLASS2::m_pFactory. 
	:
	\code
	//     
	IrmtRTClassesSearch2* pSearch;

	// 
	//         
	//  
	rmtInterface_auto_ptr<IClassFactory> pFactory;

	//  
	rmtMM_CLASS2 classinfo	= {0};

	//   
	classinfo.m_dwSize	= sizeof(rmtMM_CLASS2);

	//     
	classinfo.m_ClassID	= CLSID_CMyClass;
	classinfo.m_pFactory	= &pFactory;

	//  
	if (pSearch->FindClass(&classinfo)==NOERROR)
	{
	//    ...
	pFactory->CreateInstance(...);

	//  
	::SysFreeString(classinfo.m_ClassName);
	::SysFreeString(classinfo.m_ModuleName);
	};
	\endcode


	\warning
	   ,    pClassInfo.      
	   .

	*/
	virtual HRESULT	STDMETHODCALLTYPE	FindClass(RMT_INOUT rmtMM_CLASS* pClassInfo) RMT_PURE;
};
#define IID_IrmtRTClassesSearch2 __uuidof(IrmtRTClassesSearch2)


/*! 
\brief     .

        .

\ingroup group_rmtMClasses
\ingroup group_rmtKernelClass
*/
rmtInterface("{400A3945-B400-4997-BE6E-CD568ECF9321}")
IrmtRTClassesEnum : public IUnknown
{
	virtual HRESULT	STDMETHODCALLTYPE	Next(RMT_IN ULONG celt, RMT_OUT rmtMM_CLASS pClasses[], RMT_INOUT ULONG *pceltFetched) RMT_PURE;
	virtual HRESULT	STDMETHODCALLTYPE	Skip(RMT_IN ULONG celt) RMT_PURE;
	virtual HRESULT	STDMETHODCALLTYPE	Reset() RMT_PURE;
	virtual HRESULT	STDMETHODCALLTYPE	Clone(RMT_OUT IrmtRTClassesEnum **ppenum) RMT_PURE;
};
#define IID_IrmtRTClassesEnum __uuidof(IrmtRTClassesEnum)


/*!
\brief     .

    .

\ingroup group_rmtMModules
\ingroup group_rmtKernelModule
*/
rmtInterface("{47D79617-8011-487f-B07C-9030C6298319}")
IrmtRTModulesEnum : public IUnknown
{
	virtual HRESULT	STDMETHODCALLTYPE	Next(RMT_IN ULONG celt, RMT_OUT rmtMM_MODULE pModules[], RMT_INOUT ULONG *pceltFetched) RMT_PURE;
	virtual HRESULT	STDMETHODCALLTYPE	Skip(RMT_IN ULONG celt) RMT_PURE;
	virtual HRESULT	STDMETHODCALLTYPE	Reset() RMT_PURE;
	virtual HRESULT	STDMETHODCALLTYPE	Clone(RMT_OUT IrmtRTModulesEnum **ppenum) RMT_PURE;
};
#define IID_IrmtRTModulesEnum __uuidof(IrmtRTModulesEnum)

/*! 
\brief    .

             .
      rmtMM_MODULE
   IrmtRTModulesSearch::FindModule().

\ingroup group_rmtKernel
\ingroup group_rmtMModules
\ingroup group_rmtKernelModule
*/
rmtInterface("{6441B256-198C-46ab-B02E-F1C1A1869EF9}")
IrmtRTModulesSearch : public IUnknown
{
	/*! 
	\brief        .

	       rmtMM_MODULE, ..
	 m_ModuleName -      .

	          -  NOERROR,  -  .       
	   rmtMM_MODULE         .

	\warning
	  ,     ,       ,    .
	          .

	\param pModuleInfo   ,     ,        ,   .
	\return   HRESULT - NOERROR   ,  -  .
	*/
	virtual HRESULT	STDMETHODCALLTYPE	FindModule(RMT_INOUT rmtMM_MODULE* pModuleInfo) RMT_PURE;
};
#define IID_IrmtRTModulesSearch __uuidof(IrmtRTModulesSearch)

/*! 
\brief        .

    ,          .
  - ,      .     (. \ref rmt_page2 )
          rmtQuery(REFIID riid, LPVOID * ppv). 
 rmtKernel (. rmt_page3_rmtKernel )      :
	-   (   IrmtRTLanguage),
	-    (   IrmtRTClassesEnum  IrmtRTClassesSearch),
	-     (   IrmtModuleService),
	-    (   IrmtVersionInfo),
	-   (   IrmtRTDependency)
	-  ..

        ,    .
             ,
       rmt::CModuleService  rmt::CLocalyModuleService.  ..
   ,      rmtQuery() rmtQuery   .
       ,      rmtKernel.  
         .

\version 
- <b>1.4.51102.0</b> -    rmtKernel

\ingroup group_rmtKernelModule
*/
rmtInterface("{63FAA0D6-A2EF-4da9-87C3-54BF11345CDB}")
IrmtRTModulesService : public IUnknown
{
	/*!
	\brief     .

	           
	 ,      .
	
	\param szModuleName -  ,     .
	\param riid -   ,   .
	\retval ppvServiceObject -       .

	\note
	          Release().
	*/
	virtual HRESULT	STDMETHODCALLTYPE	QueryService(RMT_IN LPCOLESTR szModuleName, RMT_IN REFIID riid, RMT_RETVAL IUnknown** ppvServiceObject ) RMT_PURE;
};
#define IID_IrmtRTModulesService __uuidof(IrmtRTModulesService)

/*!
\brief        /.

          
  -        .

  ,       .

\note
   .

\ingroup group_rmtMModules
\ingroup group_rmtMClasses
*/
rmtInterface("{C016AD2D-2FD4-4b9f-B3E2-FBA6BF83F956}")
IrmtRTDependency : public IUnknown
{
	/*!
	\brief   ,     /.

	    ,      NOERROR,
	     -    ,  pszDescription!=NULL -    .

	\retval pszDescription -       ,    pszDescription   BSTR   .
	\return	  HRESULT - NOERROR    ()  ,  -  .
	*/
	virtual HRESULT	STDMETHODCALLTYPE	CheckDependency(RMT_INOUT LPBSTR pszDescription = NULL) RMT_PURE;
};
#define IID_IrmtRTDependency __uuidof(IrmtRTDependency)


/*!
\brief      .

 .

\ingroup group_rmtMModules
\ingroup group_rmtMClasses
\ingroup group_rmtKernelLocaly
*/
rmtInterface("{03805AC5-AF39-4d29-A81E-1FE522DBC82A}")
IrmtRTLanguage : public IUnknown
{
	/*!
	\brief  MM (, , )  .

	\param nLangID -  ,       LCID.       MAKELCID().
	\return	  HRESULT
	*/
	virtual HRESULT	STDMETHODCALLTYPE	SetLanguage(RMT_IN RMT_LCID LONG nLangID) RMT_PURE;

	/*! 
	\brief     MM (, , ).

	\retval nLangID -  ,       LCID.
	\return	  HRESULT
	*/
	virtual HRESULT	STDMETHODCALLTYPE	GetLanguage(RMT_OUT RMT_LCID LONG* nLangID) RMT_PURE;
};
#define IID_IrmtRTLanguage __uuidof(IrmtRTLanguage)



/*!
\brief   MM .

        .
   ,  ,      .

\ingroup group_rmtMModules
*/
rmtInterface("{CC208978-AF2A-4239-B7D8-EC393E177F13}")
IrmtModuleService : public IUnknown
{
	/*!
	\brief    .

	       pKernel    
	,    .    ,  
	        IrmtModuleService::Disconnect()
	*/
	virtual HRESULT	STDMETHODCALLTYPE	ConnectToKernel(RMT_IN IrmtKernel *pKernel) RMT_PURE;

	/*!
	\brief           .
	
	        IrmtModuleService::ConnectToKernel(), 
	   .     ,   
	        ( pKernel->AddRef() ).
	*/
	virtual HRESULT	STDMETHODCALLTYPE	QueryCurrentKernel(RMT_OUT IrmtKernel **pCurrentKernel) RMT_PURE;

	/*!
	\brief  ,       .
	
	          
	(    pKernel   IrmtModuleService::ConnectToKernel(),
	 ,         ).
	    ,           
	     .
	
	\param pUnloader -     .

    \version 
	- <b>1.4.50513.0</b> -    .   "" (  "")  
	    ::IrmtModuleUnloader,     
	 .   ,     rmtMM,    
	    ,     ::LoadLibrary(),  ,
	     , ..   - , 
	  ,  ::FreeLibraryAndExitThread().   ,    , 
	    ,   -  ,      
	           ,   
	    1.5 .       "" , 
	       DLL ,     
	  MM            
	 (..         ""    
	, 	     ).        ,
	        ,    .

	\warning
	           ,     
	 , -     .  ,    
	         , ..     1.4.50513.0
	    NULL   ...    ,   
	      ,      1.4.50513.0.
	
	\note
	    rmtObject.cpp        
	   ,    .
	*/
	virtual HRESULT	STDMETHODCALLTYPE	Disconnect(RMT_IN IrmtModuleUnloader *pUnloader) RMT_PURE;
};
#define IID_IrmtModuleService __uuidof(IrmtModuleService)


/*!
\brief   .

 .

\ingroup group_rmtMClasses
\ingroup group_rmtMModules
\ingroup group_rmtKernelVersion
*/
rmtInterface("{070B886D-CDC0-41a9-878B-881089CE623A}")
IrmtVersionInfo : public IUnknown
{
	/*!
	\brief    (, , ).

	\retval pdwMajor -   
	\retval pdwMinor -   
	\retval pdwBuildHi -   ()
	\retval pdwBuildLo -   ()
	\return	  HRESULT
	*/
	virtual HRESULT	STDMETHODCALLTYPE	GetVersion(RMT_INOUT WORD* pdwMajor = NULL, RMT_INOUT WORD* pdwMinor = NULL, RMT_INOUT WORD* pdwBuildHi = NULL, RMT_INOUT WORD* pdwBuildLo = NULL) RMT_PURE;
};
#define IID_IrmtVersionInfo __uuidof(IrmtVersionInfo)



/*!
\brief  .

        
  /   ..  ..  .

       .   
   .

\ingroup group_rmtValid
*/
rmtInterface("{95C69105-9FC5-4d6e-9BB0-D538343A74B2}")
IrmtValidation : public IUnknown
{
	virtual HRESULT	STDMETHODCALLTYPE	IsValid() RMT_PURE;
};
#define IID_IrmtValidation __uuidof(IrmtValidation)


/*!
\brief  .

       
           
   ( , unit testing).

\note
       IrmtValidation,
      .  
       IrmtValidation, ..
IrmtValidation::IsValid().

\ingroup group_rmtValid
*/
rmtInterface("{324978D4-0108-455c-B75D-125482D86053}")
IrmtRegressionTesting : public IrmtValidation
{
	/*!
	\brief            .
	*/
	virtual HRESULT	STDMETHODCALLTYPE	SetOutputStream(RMT_IN ISequentialStream* stream) RMT_PURE;
};
#define IID_IrmtRegressionTesting __uuidof(IrmtRegressionTesting)


/*!
\brief  .

      IClassFactory,
        - ,
 .        
 ,         .

\note
	 MM     rmtObject.h     112 
	 .

\version
	-    <b>1.4.50520.0</b>  rmtKernel    ,
	   ,       .

\ingroup group_rmtMClasses
*/
rmtInterface("{AF680FE5-B3E9-4800-B4CF-F3326279D167}")
IrmtClassFactory  : public IClassFactory
{
	/*!
	\brief  -      .  .

	 -      , .. 
	       .
	    ,      1,  
	     -   1.

	\retval pCount - -      .
	\return HRESULT	-   .
	*/
	virtual HRESULT	STDMETHODCALLTYPE	GetObjectCount(RMT_RETVAL LONG* pCount) RMT_PURE;
	
	/*!
	\brief  - -      .  .

	  -    ,   
	    .
	   IrmtClassFactory::GetObjectCount() ,  
	     ,   -   .
	..           ,  
	     1.

	\retval pCount - -      ,    1.
	\return HRESULT	-   .

	\note
		           .
		      -   .

	\note
		     ,   .   - E_NOTIMPL
	*/
	virtual HRESULT	STDMETHODCALLTYPE	GetFactoryObjectCount(RMT_RETVAL LONG* pCount) RMT_PURE;
};
#define IID_IrmtClassFactory __uuidof(IrmtClassFactory)

/*!
\brief  .

   IrmtClassFactory.

\note
	 MM     rmtObject.h     118 
	 .

\ingroup group_rmtMClasses
*/
rmtInterface("{80EE2A30-6C4C-4cec-B45B-E2411B29F8C7}")
IrmtClassFactory2  : public IrmtClassFactory
{
	/*!
	\brief    .

	      ,   .
	   ,      rmtBEGIN_INTERFACE_MAP() - rmtEND_INTERFACE_MAP(),
	     ++     CrmtObject.
	
	       , ..     IUnknown,
	    .

	     -  rmtMM_INTERFACE   . 
	   -      pInterfaces==NULL,    
	  pCount   -  . 

	\param pInterfaces -   rmtMM_INTERFACE,     .    NULL.
	\param pCount - -    pInterfaces,  pInterfaces==NULL,       -.

	\return HRESULT	-   .
	*/
	virtual HRESULT	STDMETHODCALLTYPE	GetClassInterfaces(RMT_INOUT rmtMM_INTERFACE* pInterfaces, RMT_INOUT ULONG* pCount) RMT_PURE;
};
#define IID_IrmtClassFactory2 __uuidof(IrmtClassFactory2)


/*!
\brief     .

   /   BSTR .
           
 .

\ingroup group_rmtTxtStorages
*/
rmtInterface("{01C18253-4594-4208-85AE-D0B86C472719}")
IrmtSerializeText : public IUnknown
{
	/*!
	\brief    BSTR .

	\param strContent -     .
	\return HRESULT	-   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	LoadTxt(RMT_IN BSTR strContent) RMT_PURE;
	
	/*!
	\brief    BSTR .

	\retval pstrContent -     .
	\return HRESULT	-   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	SaveTxt(RMT_RETVAL BSTR* pstrContent) const RMT_PURE;
};
#define IID_IrmtSerializeText __uuidof(IrmtSerializeText)


/*!
\brief    XML DOM .

   /   
XML ,  XML DOM .   XML DOM
 MS XML .

\ingroup group_rmtXMLDOM
*/
rmtInterface("{FF5DC63A-F37C-436f-BD52-B1B63E2284EB}")
IrmtSerializeXMLDOM : public IUnknown
{
	/*!
	\brief    XML .

	\param pXMLRootNode - XML DOM       .
	\return HRESULT	-   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	LoadXML(RMT_IN IXMLDOMNode* pXMLRootNode) RMT_PURE;

	/*!
	\brief    XML .

	      
	 ,  pXMLRootNode   .

	\retval pXMLRootNode -  XML DOM       ,  .
	\return HRESULT	-   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	SaveXML(RMT_IN IXMLDOMNode* pXMLRootNode) RMT_PURE;
};
#define IID_IrmtSerializeXMLDOM __uuidof(IrmtSerializeXMLDOM)

/*!
\brief     XML DOM .

   /   
XML ,  XML DOM .    
   /     
.   ,    ,   
     IrmtSerializeXMLDOM.

\note
  pAdditional        XML DOM.
     ,   .

\ingroup group_rmtXMLDOM
*/
rmtInterface("{727C58BD-0BD9-472f-97EB-71910E6D2955}")
IrmtSerializeXMLDOM_Additional : public IUnknown
{
	/*!
	\brief    XML .

	\param pXMLRootNode - XML DOM       .
	\return HRESULT	-   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	LoadXML(RMT_IN IXMLDOMNode* pXMLRootNode, RMT_IN IUnknown* pAdditional = NULL) RMT_PURE;

	/*!
	\brief    XML .

	      
	 ,  pXMLRootNode   .

	\retval pXMLRootNode -  XML DOM       ,  .
	\return HRESULT	-   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	SaveXML(RMT_IN IXMLDOMNode* pXMLRootNode, RMT_IN IUnknown* pAdditional = NULL) RMT_PURE;
};
#define IID_IrmtSerializeXMLDOM_Additional __uuidof(IrmtSerializeXMLDOM_Additional)


/*!
\brief    /.

   /   
       .

\ingroup group_rmtFileStorages
*/
rmtInterface("{7AC79459-7BCC-4bbe-B7EF-09277CECA2A0}")
IrmtSerializeFile : public IUnknown
{
	/*!
	\brief    /.

	\return HRESULT	-   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	LoadFile(RMT_IN LPCOLESTR szPath) RMT_PURE;

	/*!
	\brief    /.

	\return HRESULT	-   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	SaveFile(RMT_IN LPCOLESTR szPath) RMT_PURE;
};
#define IID_IrmtSerializeFile __uuidof(IrmtSerializeFile)


/*!
\brief  ,       .

       , ,  
  .        - , .

      ::CLSID_CrmtLock

\ingroup group_rmtSync
*/
rmtInterface("{9BECDBC7-965D-4e34-9182-4376A793D12F}")
IrmtLock : public IUnknown
{
	/*!
	\brief  . 
	
	      -  , 
	        .

	\return HRESULT -   
	*/
	virtual HRESULT STDMETHODCALLTYPE	Lock() RMT_PURE;

	/*!
	\brief  .
	\return HRESULT -   
	*/
	virtual HRESULT STDMETHODCALLTYPE	Unlock() RMT_PURE;
};
#define IID_IrmtLock __uuidof(IrmtLock)


/*!
\brief  ,      .

 -    ::CLSID_CrmtLock,   
  	IrmtLockMap::Key,       
  /,     .

\note
	        ,
	    ,      / .
	       -   
	  - ::rmtLockG.

\note
	       ::CLSID_CrmtLockMap.
	      , ..    
	.

\ingroup group_rmtMaps
\ingroup group_rmtSync
\ingroup group_rmtKernelSync
*/
rmtInterface("{A5EB4681-DCA4-4d4b-A8BF-2D076310A722}")
IrmtLockMap : public IUnknown
{
	/*!
	\brief       .

	\date 16.07.04 
			 Key   UINT_PTR,   LPVOID.
			 32bit   .  
			      ,         
			     int      sizeof(UINT_PTR)
	*/
	typedef UINT_PTR Key;

	/*!
	\brief  .
	*/
	virtual HRESULT STDMETHODCALLTYPE	AddLock(RMT_IN IrmtLockMap::Key LockKey) RMT_PURE;

	/*!
	\brief  .
	*/
	virtual HRESULT STDMETHODCALLTYPE	RemoveLock(RMT_IN IrmtLockMap::Key LockKey) RMT_PURE;

	/*!
	\brief    .       ,   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	QueryLock(RMT_IN IrmtLockMap::Key LockKey, RMT_RETVAL IrmtLock** pLock) RMT_PURE;

	/*!
	\brief    ,       -  .
	*/
	virtual HRESULT STDMETHODCALLTYPE	FindLock(RMT_IN IrmtLockMap::Key LockKey, RMT_RETVAL IrmtLock** pLock) RMT_PURE;
};
#define IID_IrmtLockMap __uuidof(IrmtLockMap)



/*!
\brief    .

\ingroup group_rmtUI
*/
rmtInterface("{2CBF9B0E-40B3-4135-9F2A-7237D2B23CB4}")
IrmtWnd : public IUnknown
{
	virtual HRESULT STDMETHODCALLTYPE	DestroyWnd() RMT_PURE;
	
	virtual HRESULT STDMETHODCALLTYPE	MoveWindow(RMT_IN int nX, RMT_IN int nY, RMT_IN UINT nWidth, RMT_IN UINT nHeight) RMT_PURE;
	
	virtual HRESULT STDMETHODCALLTYPE	GetWindowText(RMT_RETVAL BSTR* pstrContent) const RMT_PURE;
	
	virtual HRESULT STDMETHODCALLTYPE	SetFocus() RMT_PURE;
};
#define IID_IrmtWnd __uuidof(IrmtWnd)

/*!
\brief       .

      WM_COMMAND, 
     ,   MFC.

\note
	   1.4.60406.0   
	     .
	    
	       .

\ingroup group_rmtUI
*/
rmtInterface("{51C0BB42-43D0-4390-8B1D-5BE7EBBD13F0}")
IrmtWndCommandProc : public IUnknown
{
	/*!
	\brief     nCmdID.

	\param nCmdID -  .
	\return HRESULT -  :
		- S_OK(NOERROR)	-  .
		- S_FALSE		- ()    .
		- E_NOTIMPL		-    ,   .
		-  	-     .
	*/
	virtual HRESULT STDMETHODCALLTYPE	OnCommand(RMT_IN UINT nCmdID) RMT_PURE;

	/*!
	\brief     nCmdID,    pState

	\param nCmdID -  .
	\retval pState -   .
	\return HRESULT -  :
		- S_OK(NOERROR)	-  .
		- S_FALSE		- ()     ->  .
		- E_NOTIMPL		-     ->  , ..     .
		-  	-      ->  , ..     .     .
	*/
	virtual HRESULT STDMETHODCALLTYPE	OnUpdateCommand(RMT_IN UINT nCmdID, RMT_INOUT rmt::Wnd::CommandState *pState) RMT_PURE;
};
#define IID_IrmtWndCommandProc __uuidof(IrmtWndCommandProc)

/*!
\brief       .

      WM_NOTIFY.

\ingroup group_rmtUI
*/
rmtInterface("{E25C8269-6D2D-499d-9C4F-ACCB1DCC35ED}")
IrmtWndNotifyProc : public IUnknown
{
	/**
	 * \brief  .
	 *
	 *      ,  
	 *   nCode.     
	 *     .      
	 *    ,  .     , 
	 *       .
	 *
	 * \param nCode -   ,
	 * \param pData -      .
	 * \return HRESULT -  :
	 *		- S_OK -  .
	 *		- S_FALSE -    (  ).
	 *		- E_NOTIMPL	-    ,     .
	 *		-   -     .
	 */
	virtual HRESULT STDMETHODCALLTYPE	OnNotify(RMT_IN UINT nCode, RMT_IN const LPVOID pData) RMT_PURE;
};

/*!
\brief      .

\ingroup group_rmtUI
*/
rmtInterface("{031A1991-7F8D-4ab1-894D-ED7FC99E170A}")
IrmtChildWnd : public IrmtWnd
{
	virtual HRESULT STDMETHODCALLTYPE	CreateWnd(RMT_IN HWND hParentWnd, RMT_IN int x, RMT_IN int y, RMT_IN int nWidth, RMT_IN int nHeight, RMT_IN UINT nID) RMT_PURE;
};
#define IID_IrmtChildWnd __uuidof(IrmtChildWnd)


/*!
\brief     popup .

\ingroup group_rmtUI
*/
rmtInterface("{0416E186-0838-4fe7-88C9-314B34F50AC7}")
IrmtPopupWnd : public IrmtWnd
{
	virtual HRESULT STDMETHODCALLTYPE	CreateWnd(RMT_IN HWND hParentWnd, RMT_IN int x, RMT_IN int y, RMT_IN int nWidth, RMT_IN int nHeight) RMT_PURE;
	virtual HRESULT STDMETHODCALLTYPE	SetLayerOpacity(RMT_IN BYTE nAlpha) RMT_PURE;
	virtual HRESULT STDMETHODCALLTYPE	SetLayerColorKey(RMT_IN COLORREF clKey) RMT_PURE;
};
#define IID_IrmtPopupWnd __uuidof(IrmtPopupWnd)


/*! 
\brief     .

    ,     
     .   
     .
*/
rmtInterface("{D4F3D29A-AA75-49ae-BA3E-AEB99E143E76}")
IrmtPrinting : public IUnknown
{
	/*!
	\brief .

	     DC,   .

	\warnig
	       ,  
	   (  NULL)    .    E_NOTIMPL, 
	 ,           .
	    -  ,  E_INVALIDARG,  ,
	            .
	     ,    exception    
	     , ,   ,
	    E_INVALIDARG.

	\param hPrinterDC -  DC ,      .
	\param pPrintRect -       hPrinterDC.
	\return HRESULT -   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	Print(RMT_IN HDC hPrinterDC, RMT_IN LPCRECT pPrintRect) RMT_PURE;
};
#define IID_IrmtPrinting __uuidof(IrmtPrinting)


/*!
\brief           ( ).

\ingroup group_rmtUI
*/
rmtInterface("{0E2A81E5-4326-41f5-B2B3-F5412F174768}")
IrmtFullScreen : public IUnknown
{
	enum modes
	{
		modeFullScreen	= 0x0,
		modeWindowed	= 0x1,
		
		modeBogusLast	= 0xFFFF
	};

	/*!
	\brief   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	SwitchMode(RMT_IN IrmtFullScreen::modes nMode) RMT_PURE;
	
	/*!
	\brief          .

	\return HRESULT -   : 
		- NOERROR -  .
		-   E_?? -  .
	*/
	virtual HRESULT STDMETHODCALLTYPE	TestMode(RMT_IN IrmtFullScreen::modes nMode) RMT_PURE;
	
	/*!
	\brief   .
	
	\return HRESULT -   : 
		- NOERROR -    nMode.
		-   E_?? -  .
	*/
	virtual HRESULT STDMETHODCALLTYPE	IsMode(RMT_IN IrmtFullScreen::modes nMode) const RMT_PURE;
};
#define IID_IrmtFullScreen __uuidof (IrmtFullScreen)



/*!
\brief  -    

\param LPARAM -  ,      
       .

\ingroup group_rmtDelayCall
*/
typedef void (CALLBACK* rmtDELAYPROC)(/*RMT_IN*/ LPARAM);

namespace rmt
{
	namespace Time
	{
		namespace Timer
		{
			/*!
			\brief    .
			
			\ingroup group_rmtTimer
			*/
			enum state
			{
				s_Stoped,		//!<   .
				s_Activated,	//!<  .

				s_BogusLast
			};

			/*!
			\brief    .
			
			\ingroup group_rmtTimer
			*/
			enum timeunit
			{
				tu_ms,			//!< 
				tu_mks,			//!< 

				tu_BogusLast
			};

			/*!
			\brief    .

			\ingroup group_rmtTimer
			*/
			struct Event
			{
				DWORD				m_dwSize;					//!<  .
				timeunit			m_nUnit;					//!<   .
				ULONGLONG			m_nTime;					//!<     ,      .
				HANDLE				m_hEvent;					//!<  .

				Event()
					: m_dwSize(sizeof(Event))
					, m_nUnit(tu_ms)
					, m_nTime(0)
					, m_hEvent(NULL)
				{
				}
			};
		}
	}
}

/*!
\brief  .

      .
<b></b> -        . 
 ,           
    .       
     (. rmt::Time::Timer::timeunit).


        
 (Event),         .
     IrmtTimer::SetEvent().


       IrmtTimer::GetState().


   :
	- CLSID_CrmtTimer

\ingroup group_rmtTimer
*/
rmtInterface("{435E1FFD-CF0D-4a82-AA2C-510A172505BE}")
IrmtTimer : public IUnknown
{
	/*!
	\brief    .

	\param pState -      .
	\return HRESULT -   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	GetState(RMT_RETVAL rmt::Time::Timer::state* pState) RMT_PURE;
	
	/*!
	\brief  .

	  ,     ,      .
	
	\return HRESULT -   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	Start() RMT_PURE;
	
	/*!
	\brief  .

	 .   , ,   ,  
	        .
	
	\return HRESULT -   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	Stop() RMT_PURE;
	
	/*!
	\brief       .

	\param nUnit -      .
	\param pTime -     .
	\return HRESULT -   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	GetTime(RMT_IN rmt::Time::Timer::timeunit nUnit, RMT_RETVAL ULONGLONG* pTime) RMT_PURE;

	/*!
	\brief          .

	    ,   ,  
	     .

	\param pEvent -   ,  .
	\return HRESULT -   .

	\warning
		    !  ,       
		           .
	*/
	virtual HRESULT STDMETHODCALLTYPE	SetEvent(RMT_IN rmt::Time::Timer::Event *pEvent) RMT_PURE;
	
	/*!
	\brief    .

	    ,       SetEvent().

	\param hEvent -  .
	\return HRESULT -   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	DeleteEvent(RMT_IN HANDLE hEvent) RMT_PURE;

};
#define IID_IrmtTimer __uuidof (IrmtTimer)



/*!
\brief  .

  IrmtTimer.    
     ,   . 

         /   
    .


   :
	- CLSID_CrmtTimer

\ingroup group_rmtTimer
*/
rmtInterface("{1123786B-2C25-43c8-9147-5F96C0985F6F}")
IrmtTimer2 : public IrmtTimer
{
	/*!
	\brief           .

	     .        . 
	,   ,          
	  .

	\param pEvent -  ,  .
	\param nCount - -   .
	\return HRESULT -   .

	\warning
		    !  ,       
		           .
	*/
	virtual HRESULT STDMETHODCALLTYPE	SetEvents(RMT_IN rmt::Time::Timer::Event *pEvents, RMT_IN UINT nCount) RMT_PURE;

	/*!
	\brief    .

	    ,      SetEvent()  SetEvents().

	\param phEvents -   .
	\param nCount - -   .
	\return HRESULT -   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	DeleteEvents(RMT_IN HANDLE *phEvents, RMT_IN UINT nCount) RMT_PURE;

	/*!
	\brief   .

	      ,       SetEvent().
	
	\return HRESULT -   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	DeleteAllEvents() RMT_PURE;
};
#define IID_IrmtTimer2 __uuidof (IrmtTimer2)

/*!
\brief      .

        
.

      :
- ::CLSID_CrmtDelayCallBack
- ::CLSID_CrmtDelayCallBackWT
- ::CLSID_CrmtDelayCallBackAPC 
- ::CLSID_CrmtDelayCallBackHQT

\ingroup group_rmtDelayCall
*/
rmtInterface("{44AF9305-EB0A-40ed-BD46-2CE2C5DD72CA}")
IrmtDelayCall : public IUnknown
{
	/*!
	\brief     .

	 ,      . 
	      rmtDELAYPROC.
	 data,  ,       .

	\param proc -     .
	\param data -       .
	\param nDelay_ms -   .          .
	\param bRunImmediately -       ?
	\return HRESULT -   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	SetDelayCallBack(RMT_IN rmtDELAYPROC proc, RMT_IN LPARAM data, RMT_IN UINT nDelay_ms, RMT_IN bool bRunImmediately = false) RMT_PURE;

	/*!
	\brief   .

	   .        
	 .   ,    ,      .
	              . 
	             
	     .

	\return HRESULT -   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	DelayRun() RMT_PURE;
};
#define IID_IrmtDelayCall __uuidof(IrmtDelayCall)

/*!
\brief   IrmtDelayCall.

     .

 :
- ::CLSID_CrmtDelayCallBack

\ingroup group_rmtDelayCall
*/
rmtInterface("{040A3D66-93DD-4984-9C8C-D6736617E3C1}")
IrmtDelayCall2 : public IrmtDelayCall
{
	virtual HRESULT STDMETHODCALLTYPE	DelayPeriodicRun() RMT_PURE;
};
#define IID_IrmtDelayCall2 __uuidof(IrmtDelayCall2)

/*!
\brief      .

         (Event)
  .

 :
	- ::CLSID_CrmtDelayCallBack
	- ::CLSID_CrmtDelayCallBackWT
	- ::CLSID_CrmtDelayCallBackHQT

\ingroup group_rmtDelayCall
*/
rmtInterface("{5CA78C07-D613-42fd-931C-E16EF1E787C7}")
IrmtDelaySetEvent : public IUnknown
{
	/*!
	\brief     .

	 ,        .
	
	\param hEvent -  .
	\param nDelay_ms -   .          .
	\param bRunImmediately -       ?
	\return HRESULT -   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	SetDelayEvent(RMT_IN HANDLE hEvent, RMT_IN UINT nDelay_ms, RMT_IN bool bRunImmediately = false) RMT_PURE;
	
	/*!
	\brief   .

	   .        
	 .   ,    ,     
	  .
	
	\note
		          , 
		 .
	
	\note
		    .

	\return HRESULT -   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	DelayRun() RMT_PURE;
};
#define IID_IrmtDelaySetEvent __uuidof(IrmtDelaySetEvent)


/*!
\brief     .

       , 
         
   .

       ::CLSID_CrmtIconPool.

\ingroup group_rmtUI
\ingroup group_rmtCaches
*/
rmtInterface("{31A5CA70-F1A8-4d7f-9D7B-CEBF8A3D66CC}")
IrmtIconPool : public IUnknown
{
	/*!
	\brief  .

	         .  
	      ,    
	 ,    .

	\param hModule -       .
	\param nIconID -      .
	\param nWidth -   ,  nWidth == 0,        ( 32 ).
	\param nHeight -   ,  nHeight == 0,        ( 32 ).
	\param bMonochrome -    ,   ,     .
	\return HICON -   .    - NULL.
	*/
	virtual HICON STDMETHODCALLTYPE		LoadIcon(RMT_IN HINSTANCE hModule, RMT_IN UINT nIconID, RMT_IN int nWidth = 0, RMT_IN int nHeight = 0, RMT_IN bool bMonochrome = false) RMT_PURE;
	
	/*!
	\brief    .

	       .   ,    .

	\param nIconID -   (      ).
	\param nWidth -   ,  nWidth == 0,        ( 32 ).
	\param nHeight -   ,  nHeight == 0,        ( 32 ).
	\param bMonochrome -    ,   ,     .
	\return HICON -   .    - NULL.
	*/
	virtual HICON STDMETHODCALLTYPE		FindIcon(RMT_IN UINT nIconID, RMT_IN int nWidth = 0, RMT_IN int nHeight = 0, RMT_IN bool bMonochrome = false) RMT_PURE;
	
	/*!
	\brief    .

	     .         , 
	 ,    .           
	       ,      .

	\param hIcon -   .
	\param nIconID -  .
	\param bMonochrome -        ?
	\return HRESULT -   .
	*/
	virtual HRESULT	STDMETHODCALLTYPE	AddIcon(RMT_IN HICON hIcon, RMT_IN UINT nIconID, RMT_IN bool bMonochrome = false) RMT_PURE;
};
#define IID_IrmtIconPool __uuidof(IrmtIconPool)



/*!
\brief      -.

       -, 
    ::IrmtLocalResourceManager.   
            .

\ingroup group_rmtLocaly
*/
rmtInterface("{1B07277A-9658-4752-A0E4-CF6E2FB3E9BB}")
IrmtLocalResource: public IUnknown
{
	/*!
	\brief       .

	\retval pszPath -     .
	\return HRESULT -   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	GetResourcePath(RMT_RETVAL LPBSTR pszPath) RMT_PURE;

	/*!
	\brief    .

	          ::IrmtLocalResourceManager.

	\retval pszDescription -   .
	\return HRESULT -   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	GetDescription(RMT_RETVAL LPBSTR pszDescription) RMT_PURE;
	
	/*!
	\brief    .

	     LCID     .

	\retval pLangID -  ,    LCID.
	\return HRESULT -   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	GetDefaultLCID(RMT_RETVAL RMT_LCID LONG* pLangID) RMT_PURE;
	
	virtual HRESULT STDMETHODCALLTYPE	GetCollateLCID(RMT_RETVAL RMT_LCID LONG* pLangID) RMT_PURE;
	virtual HRESULT STDMETHODCALLTYPE	GetCtypeLCID(RMT_RETVAL RMT_LCID LONG* pLangID) RMT_PURE;
	virtual HRESULT STDMETHODCALLTYPE	GetMonetaryLCID(RMT_RETVAL RMT_LCID LONG* pLangID) RMT_PURE;
	virtual HRESULT STDMETHODCALLTYPE	GetNumericLCID(RMT_RETVAL RMT_LCID LONG* pLangID) RMT_PURE;
	virtual HRESULT STDMETHODCALLTYPE	GetTimeLCID(RMT_RETVAL RMT_LCID LONG* pLangID) RMT_PURE;

	/*!
	\brief      .

	  -     LCID    .
	
	\param nLangID -  ,    LCID.
	\retval pszLocateString -    .
	\return HRESULT -   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	ConvertLCID2LocateString(RMT_IN RMT_LCID LONG nLangID, RMT_RETVAL LPBSTR pszLocateString) RMT_PURE;
};
#define IID_IrmtLocalResource __uuidof(IrmtLocalResource)

/*!
\brief     -.

       , 
     .       ::IrmtLocalResource

     ::CLSID_CrmtLocalResourceManager.

\ingroup group_rmtLocaly
*/
rmtInterface("{0C2284E1-52F6-4fa9-8AB2-894836DAC6BD}")
IrmtLocalResourceEnum : public IUnknown
{
	virtual HRESULT	STDMETHODCALLTYPE	Next(RMT_IN ULONG celt, RMT_OUT IrmtLocalResource** pResources, RMT_INOUT ULONG *pceltFetched) RMT_PURE;
	virtual HRESULT	STDMETHODCALLTYPE	Skip(RMT_IN ULONG celt) RMT_PURE;
	virtual HRESULT	STDMETHODCALLTYPE	Reset() RMT_PURE;
	virtual HRESULT	STDMETHODCALLTYPE	Clone(RMT_OUT IrmtLocalResourceEnum **ppenum) RMT_PURE;
};
#define IID_IrmtLocalResourceEnum __uuidof(IrmtLocalResourceEnum)

/*!
\brief       .

      , 
  /, ,  .

     ::CLSID_CrmtLocalResourceManager.

\ingroup group_rmtLocaly
*/
rmtInterface("{5E83400A-2749-423f-B773-7C09A99856F8}")
IrmtLocalResourceManager : public IUnknown
{
	/*!
	\brief     .

	    -    szResourcePath.  ,
	          .
	
	\param szResourcePath -   -.    "*", "?"  ..
	\return HRESULT -   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	AddResources(RMT_IN BSTR szResourcePath) RMT_PURE;

	/*!
	\brief        .

	             ,
	     ,     LCID.

	\param nLangID -      .   -     LCID.
	\retval pLocalResource -      ,    .
	\return HRESULT -   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	QueryResourceByLandID(RMT_LCID LONG nLangID, RMT_OUT IrmtLocalResource** pLocalResource) RMT_PURE;
	
	/*!
	\brief        .

	             ,
	    .

	\param szDescription -    .
	\retval pLocalResource -      ,    .
	\return HRESULT -   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	QueryResourceByDescription(RMT_IN BSTR szDescription, RMT_OUT IrmtLocalResource** pLocalResource) RMT_PURE;
};
#define IID_IrmtLocalResourceManager __uuidof(IrmtLocalResourceManager)



/*!
\brief    "-".

     -, 
      .     
 .      - ,     VARIANT.

     ::CLSID_CrmtTextMap.

\ingroup group_rmtMaps
*/
rmtInterface("{570864D8-8585-4f64-A816-379414A5E647}")
IrmtTextMap : public IUnknown
{
	/*!
	\brief     .

	     .     
	 -  .

	\param strKey -  
	\retval pData -    .        .
	\return HRESULT -   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	Get(RMT_IN LPCOLESTR strKey, RMT_RETVAL VARIANT *pData) RMT_PURE;
	
	/*!
	\brief     .

	    .     
	 ,      .

	\param strKey -  
	\retval pData -   .      ,        .
	\return HRESULT -   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	Set(RMT_IN LPCOLESTR strKey, RMT_IN VARIANT Data) RMT_PURE;
	
	/*!
	\brief   .

	   .

	\retval pnSize -       .
	\return HRESULT -   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	GetCount(RMT_RETVAL ULONG *pnSize) RMT_PURE;

	/*!
	\brief      .

	     .      ,    

	\param pstrKey -       .        .
	\retval pData -    .        .
	\return HRESULT -   .
	*/
	virtual HRESULT STDMETHODCALLTYPE	GetItem(RMT_IN ULONG nIndex, RMT_INOUT BSTR *pstrKey, RMT_RETVAL VARIANT *pData) RMT_PURE;
};
#define IID_IrmtTextMap __uuidof(IrmtTextMap)



//    "-"
rmtInterface("{782784C9-0AD8-4eb5-8864-12692A684EB9}")
IrmtHistoryList : public IUnknown
{
	virtual HRESULT	STDMETHODCALLTYPE	AddTextHistory(RMT_IN BSTR szText, RMT_INOUT PUINT pIndex = NULL) RMT_PURE;
};
#define IID_IrmtHistoryList __uuidof(IrmtHistoryList)





// .  
extern const __declspec(selectany) CLSID CLSID_CrmtKernel			= { 0x20862ae, 0x75a9, 0x4401, { 0x81, 0xe6, 0x59, 0x49, 0xdd, 0x18, 0xa4, 0x7b } };
#define defCLSID_CrmtKernel												"{020862AE-75A9-4401-81E6-5949DD18A47B}"



/*!
\brief   (-) .

 (-)      ,     GDI .  
  Windows    ,    ,       ,  ,
         .     . ,  
 ,       .      ,   
    -  .
\n
<b> :</b> IrmtIconPool\n
\n
<b> :</b>\n
-#   
-#   IrmtIconPool
-#    IrmtIconPool
-#      IrmtIconPool

<b>:</b>
\code
// 
typedef rmtInterface_auto_ptr<IrmtIconPool> IrmtIconPool_auto;

// 1.  2.     
IrmtIconPool_auto pIconPool;
rmt::GetKernel()->CreateObjectByID(CLSID_CrmtIconPool,IID_IrmtIconPool, (void**)&pIconPool);

// 3. 
// .  ( )
HICON ico = pIconPool->LoadIcon(rmt::GetCurrentLocalResourceInstance(),IDI_MYICON);
// .... 
// .   (     )
HICON ico2 = pIconPool->LoadIcon(rmt::GetCurrentLocalResourceInstance(),IDI_MYICON);

// 4.       :)
\endcode

\ingroup group_rmtUI
\ingroup group_rmtCaches
*/
extern const __declspec(selectany) CLSID CLSID_CrmtIconPool			= { 0x6b5c1c36, 0xefcb, 0x4661, { 0xa3, 0x87, 0x87, 0x9f, 0xf1, 0x35, 0x8d, 0x16 } };
#define defCLSID_CrmtIconPool											"{6B5C1C36-EFCB-4661-A387-879FF1358D16}"



/*!
\brief    .

     IrmtTimer   
      .  
         (. ::GetSystemTimeAdjustment()) -
  10   15  (  ).

 :
	- IrmtTimer

\ingroup group_rmtTimer
*/
extern const __declspec(selectany) CLSID CLSID_CrmtTimer			= { 0xcb7a2ccb, 0xb6c6, 0x4f5a, { 0x9b, 0x80, 0x50, 0xd2, 0x43, 0xc8, 0x8, 0x6d } };
#define defCLSID_CrmtTimer												"{CB7A2CCB-B6C6-4f5a-9B80-50D243C8086D}"


/*!
\brief     ,      .

      .       
   1 ,  ,         
 10 . ,  ,        
      .

\note
	    CPU     1 .
	     10 .


 :
	- IrmtDelayCall
	- IrmtDelayCall2
	- IrmtDelaySetEvent

\note
	  ,      ,      ,
	   .  ,       
	  . ,       (IrmtDelayCall  IrmtDelayCall2),
	     (IrmtDelaySetEvent),         
	   .


\ingroup group_rmtDelayCall
*/
extern const __declspec(selectany) CLSID CLSID_CrmtDelayCallBack	= { 0x387c808a, 0xbe7f, 0x4592, { 0xac, 0xea, 0x48, 0xee, 0xb5, 0x8f, 0xb6, 0x7b } };
#define defCLSID_CrmtDelayCallBack										"{387C808A-BE7F-4592-ACEA-48EEB58FB67B}"



/*!
\brief     ,    .

       (Waitable Timer)    "" .
      +- 10 .    ,    
     ,         
 10 .

\note
	    ,  CPU    .
	   10 .

\warning
	     10-14 , ..      .

 :
	- IrmtDelayCall
	- IrmtDelaySetEvent

\ingroup group_rmtDelayCall
*/
extern const __declspec(selectany) CLSID CLSID_CrmtDelayCallBackWT	= { 0xb5c2474b, 0xc3e4, 0x4e20, { 0xac, 0xd8, 0x20, 0x14, 0xb9, 0x30, 0xb6, 0x86 } };
#define defCLSID_CrmtDelayCallBackWT									"{B5C2474B-C3E4-4e20-ACD8-2014B930B686}"



/*!
\brief     ,   APC (  )  .

    APC (  )  .     
   ,       ,       
.          API  SleepEx(...,TRUE)   .

 :
	- IrmtDelayCall

\warning 
	 MFC 6.0       , ..  MFC    APC .
	        ,  :
	\code
	BOOL CMyApp::OnIdle()
	{
		SleepEx(0,TRUE);
		return TRUE;
	}
	\endcode

\ingroup group_rmtDelayCall
*/
extern const __declspec(selectany) CLSID CLSID_CrmtDelayCallBackAPC	= { 0x2934ed40, 0x143a, 0x4e0b, { 0xaa, 0x6d, 0xb4, 0x6c, 0xc7, 0xee, 0xe6, 0x6d } };
#define defCLSID_CrmtDelayCallBackAPC									"{2934ED40-143A-4e0b-AA6D-B46CC7EEE66D}"


/*!
\brief     ,     .

           ,  
   	    QueryPerformanceCounter()  QueryPerformanceFrequency().

    1 ,  ,          CLSID_CrmtDelayCallBack.

\note
	    CPU     1 .
	     10 .


 :
	- IrmtDelayCall
	- IrmtDelaySetEvent

\note
	  ,      ,      ,
	   .  ,       
	  . ,       (IrmtDelayCall),
	     (IrmtDelaySetEvent),         
	   .


\ingroup group_rmtDelayCall
*/
extern const __declspec(selectany) CLSID CLSID_CrmtDelayCallBackHQT	= { 0x7f44d697, 0x7b2a, 0x4cef, { 0x9e, 0x92, 0x37, 0x8c, 0x85, 0x45, 0x24, 0x4d } };
#define defCLSID_CrmtDelayCallBackHQT									"{7F44D697-7B2A-4CEF-9E92-378C8545244D}"


/*!
\brief     ,      .

       .     
,   .         
 .  ,       ,    CLSID_CrmtDelayCallBackWT,
      10 .

\note
	    ,  CPU    .
	   10 .

\warning
	     10-14 , ..      .

 :
	- IrmtDelayCall
	- IrmtDelaySetEvent

\note
	  ,      ,      ,
	   .  ,       
	  . ,       (IrmtDelayCall),
	     (IrmtDelaySetEvent),         
	   .

\ingroup group_rmtDelayCall
*/
extern const __declspec(selectany) CLSID CLSID_CrmtDelayCallBackTQT	= { 0x5d814564, 0xc2eb, 0x4e25, { 0x86, 0x7, 0x36, 0x87, 0x3c, 0x97, 0x85, 0x85 } };
#define defCLSID_CrmtDelayCallBackTQT									"{5D814564-C2EB-4e25-8607-36873C978585}"

/*!
\brief     .

        -.
     XML ,    -.
        <b>HTML</b>   <b>LOCALIZATION.XML</b>.
   (    , LCID = 1049) :

\code
<?xml version="1.0" encoding="utf-8" ?>
<localization>
	
	<!--        -->
	<localizationIdentity>
	
		<!--    -->
		<description> </description>
		
		<!-- 
			        .
			 ,   .
		-->
		<category name="ALL">
			<!--    LCID -->
			<LCID name="1049"/>	
		</category>
		
		<!-- 
			  - strcoll, _stricoll, wcscoll, _wcsicoll, strxfrm, _strncoll, _strnicoll, _wcsncoll, _wcsnicoll, wcsxfrm.
			   ,        -   .
		-->
		<category name="COLLATE">
			<LCID name="1049"/>	
		</category>
		
		<!-- 
			  -   (  isdigit, isxdigit, mbstowcs, mbtowc).
			   ,        -   .
		-->
		<category name="CTYPE">
			<LCID name="1049"/>	
		</category>
		
		<!-- 
			          (- localeconv).
			   ,        -   .
		-->
		<category name="MONETARY">
			<LCID name="1049"/>	
		</category>
		
		<!-- 
			    ->   (: printf),  
			      - localeconv.

			   ,        -   .
		-->
		<category name="NUMERIC">
			<LCID name="1033"/>	
		</category>
		
		<!-- 
			   strftime  wcsftime, ..      .
			   ,        -   .
		-->
		<category name="TIME">
			<LCID name="1049"/>	
		</category>
		
	</localizationIdentity>
	
</localization>
\endcode

<b> :</b>
	- IrmtLocalResourceManager
	- IrmtLocalResourceEnum

\ingroup group_rmtLocaly
*/
extern const __declspec(selectany) CLSID CLSID_CrmtLocalResourceManager	= { 0x6c004d0a, 0x1047, 0x4712, { 0xad, 0x36, 0x55, 0x68, 0x7f, 0x40, 0x54, 0xd3 } };
#define defCLSID_CrmtLocalResourceManager								"{6C004D0A-1047-4712-AD36-55687F4054D3}"

/*!
\brief    .

     ::IrmtLockMap -  -   
 ::CLSID_CrmtLock,       IrmtLockMap::Key.

<b> :</b> IrmtLockMap

\ingroup group_rmtMaps
\ingroup group_rmtSync
*/
extern const __declspec(selectany) CLSID CLSID_CrmtLockMap			= { 0x2ff46c57, 0xc8cf, 0x4d4f, { 0x83, 0x5f, 0x35, 0x5c, 0xac, 0x9b, 0xb6, 0x50 } };
#define defCLSID_CrmtLockMap											"{2FF46C57-C8CF-4d4f-835F-355CAC9BB650}"

/*!
\brief   .

     IrmtLock - 
    .    
 .

<b> :</b> IrmtLock

\ingroup group_rmtSync
*/
extern const __declspec(selectany) CLSID CLSID_CrmtLock				= { 0xc297c969, 0xd9fd, 0x4cdb, { 0x95, 0x5a, 0xe9, 0x23, 0xc9, 0x40, 0x19, 0x7f } };
#define defCLSID_CrmtLock												"{C297C969-D9FD-4cdb-955A-E923C940197F}"


// .   - "-"
extern const __declspec(selectany) CLSID CLSID_CrmtHistoryList		= { 0xd0787a3, 0xbb4, 0x4309, { 0xbc, 0xde, 0x5d, 0x56, 0x20, 0xeb, 0xb, 0xa1 } };
#define defCLSID_CrmtHistoryList										"{0D0787A3-0BB4-4309-BCDE-5D5620EB0BA1}"


/*!
\brief    -.

     IrmtTextMap - -
       .    
   /  ,    
 ""  VARIANT.

<b> :</b> IrmtTextMap

\ingroup group_rmtMaps
*/
extern const __declspec(selectany) CLSID CLSID_CrmtTextMap			= { 0x84d6957c, 0x885b, 0x4d3f, { 0xb1, 0x64, 0xe4, 0x5b, 0x50, 0xb6, 0x54, 0xda } };
#define defCLSID_CrmtTextMap											"{84D6957C-885B-4d3f-B164-E45B50B654DA}"



namespace rmt
{
	namespace Tools
	{
		/*!
		\brief  GUID.

		  GUID   true   .

		\return true - GUID .
		\return false - GUID .

		\ingroup group_rmtTools
		*/
		__forceinline bool	GUIDIsEqual(/*RMT_IN*/ REFGUID rguid1, /*RMT_IN*/ REFGUID rguid2)
		{
			return (
				(((LONG*) &rguid1)[0] == ((LONG*) &rguid2)[0]) &
				(((LONG*) &rguid1)[1] == ((LONG*) &rguid2)[1]) &
				(((LONG*) &rguid1)[2] == ((LONG*) &rguid2)[2]) &
				(((LONG*) &rguid1)[3] == ((LONG*) &rguid2)[3]));
		}

		/*!
		\brief     .

		      
		.

		\warning
		 -       IUnknown.

		\param pObjUnk - ,      .
		\return   ,  ULONG.

		\ingroup group_rmtTools
		*/
		template<typename TInterface>
		inline ULONG GetReferenceCount(TInterface* pObjUnk)
		{
			//        IUnknown
			C_ASSERT( RMT_SUPERSUBCLASS(IUnknown, TInterface) );

			const ULONG nRef = pObjUnk->AddRef();
			pObjUnk->Release();

			return (nRef-1);
		}
	}
}



///////////////////////////////////////////////////////////////////////////////
//  Inline 
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//  Inline 
///////////////////////////////////////////////////////////////////////////////


#endif // _RMTINTERFACES_H__INCLUDED_